using namespace std;
#include <iostream>
#include <fstream>
#include <math.h>

int main() {

//
// get correlation factors
//
  float rxy;
  float rxz;
  float ryz;
  cout << "rxy,rxz,ryz > " << flush;
  cin >> rxy >> rxz >> ryz;

//
// check covariance matrix
//
  float det = ( 1.0 + ( 2.0 * rxy * ryz * rxz ) ) -
              ( pow( rxy, 2 ) + pow( ryz, 2 ) + pow( rxz, 2 ) );
  if ( det <= 0 ) {
    cout << "error matrix not pos.def." << endl;
    return 0;
  }

//
// compute combination factors
//
  float sta = rxz;
  float cta = sqrt( 1.0 - pow( sta, 2 ) );
  float stb = ryz;
  float ctb = sqrt( 1.0 - pow( stb, 2 ) );
  float stc = ( rxy - ( sta * stb ) ) / ( cta * ctb ); 
  float ctc = sqrt( 1.0 - pow( stc, 2 ) );
  cout << "sen(ta) = " << sta << " ; "
       << "cos(ta) = " << cta << endl;
  cout << "sen(tb) = " << stb << " ; "
       << "cos(tb) = " << ctb << endl;
  cout << "sen(tc) = " << stc << " ; "
       << "cos(tc) = " << ctc << endl;

//
// open file
//
  ifstream file( "flat.dat" );
  int n = 0;

//
// initialize counters
//
  float stx = 0.0;
  float sty = 0.0;
  float stz = 0.0;
  float sxx = 0.0;
  float syy = 0.0;
  float szz = 0.0;
  float sxy = 0.0;
  float sxz = 0.0;
  float syz = 0.0;

//
// random variables
//

// flat
  float p;
  float q;
// gaussian
  float a;
  float b;
  float c;
  float d;
// correlated
  float x;
  float y;
  float z;

//
// loop
//
  while ( n++ < 2500 ) {

// read file and transform to gaussian
    file >> p >> q;
    a = sqrt( -2.0 * log( p ) ) * cos( 2.0 * M_PI * q );
    b = sqrt( -2.0 * log( p ) ) * sin( 2.0 * M_PI * q );
    file >> p >> q;
    c = sqrt( -2.0 * log( p ) ) * cos( 2.0 * M_PI * q );
    d = sqrt( -2.0 * log( p ) ) * sin( 2.0 * M_PI * q );

// transform to correlated
    x = ( a * cta * ctc ) +
        ( b * cta * stc ) +
        ( c * sta );
    y = ( b * ctb ) +
        ( c * stb );
    z =   c;

// update counters
    stx += x;
    sty += y;
    stz += z;
    sxx += x * x;
    syy += y * y;
    szz += z * z;
    sxy += x * y;
    sxz += x * z;
    syz += y * z;

  }

//
// compute averages
//
  float avx = stx / n;
  float avy = sty / n;
  float avz = stz / n;
  cout << "medie: " << avx << " " << avy << " " << avz << endl;

//
// compute rms
//
  float erx = sqrt( ( sxx / n ) - pow( avx, 2 ) );
  float ery = sqrt( ( syy / n ) - pow( avy, 2 ) );
  float erz = sqrt( ( szz / n ) - pow( avz, 2 ) );
  cout << "sigma: " << erx << " " << ery << " " << erz << endl;

//
// compute correlation factors
//
  rxy = ( ( sxy / n ) - ( avx * avy ) ) / ( erx * ery );
  rxz = ( ( sxz / n ) - ( avx * avz ) ) / ( erx * erz );
  ryz = ( ( syz / n ) - ( avy * avz ) ) / ( ery * erz );
  cout << "corr:  " << rxy << " " << rxz << " " << ryz << endl;

  return 0;

}


